package com.github.itzilly.sbt

import net.minecraft.client.settings.KeyBinding
import net.minecraftforge.fml.client.registry.ClientRegistry
import org.lwjgl.input.Keyboard

object STBKeyBinds {
    lateinit var searchForChests: KeyBinding
    lateinit var clearChests: KeyBinding
    lateinit var toggleGrottoFinder: KeyBinding
    lateinit var clearGrotto: KeyBinding
    lateinit var findGemstones: KeyBinding
    lateinit var clearGemstones: KeyBinding

    lateinit var toggleLeftWalk: KeyBinding
    lateinit var toggleRightWalk: KeyBinding
    lateinit var toggleForwardWalk: KeyBinding
    lateinit var toggleBackwardWalk: KeyBinding

    lateinit var toggleLeftMouse: KeyBinding

    fun init() {
        searchForChests = KeyBinding("key.xraySearch", Keyboard.KEY_F10, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(searchForChests)

        clearChests = KeyBinding("key.xrayClear", Keyboard.KEY_MINUS, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(clearChests)

        toggleGrottoFinder = KeyBinding("key.toggleGrottoFinder", Keyboard.KEY_N, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(toggleGrottoFinder)

        clearGrotto = KeyBinding("key.clearGrotto", Keyboard.KEY_F1, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(clearGrotto)

        findGemstones = KeyBinding("key.findGemstones", Keyboard.KEY_J, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(findGemstones)

        clearGemstones = KeyBinding("key.clearGemstones", Keyboard.KEY_K, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(clearGemstones)

        // -----------------------
        //      Macro Toggle
        // -----------------------
        toggleLeftWalk = KeyBinding("key.toggleLeftWalk", Keyboard.KEY_LEFT, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(toggleLeftWalk)

        toggleRightWalk = KeyBinding("key.toggleRightWalk", Keyboard.KEY_RIGHT, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(toggleRightWalk)

        toggleForwardWalk   = KeyBinding("key.toggleForwardWalk", Keyboard.KEY_UP, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(toggleForwardWalk)

        toggleBackwardWalk = KeyBinding("key.toggleBackwardWalk", Keyboard.KEY_DOWN, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(toggleBackwardWalk)

        toggleLeftMouse = KeyBinding("key.toggleLeftMouse", Keyboard.KEY_PRIOR, "key.categories.sbt")
        ClientRegistry.registerKeyBinding(toggleLeftMouse)
    }
}