package com.github.itzilly.sbt.features

import com.github.itzilly.sbt.STBKeyBinds.toggleLeftWalk;
import com.github.itzilly.sbt.features.gardener.CaneMacroer
import com.github.itzilly.sbt.util.Chatterbox
import net.minecraft.client.Minecraft
import net.minecraft.client.gui.Gui
import net.minecraft.client.gui.GuiChat
import net.minecraftforge.client.event.RenderGameOverlayEvent
import net.minecraftforge.common.MinecraftForge
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.common.gameevent.InputEvent
import net.minecraftforge.fml.common.gameevent.TickEvent
import org.lwjgl.input.Keyboard


object FarmHelper {

    private val mc: Minecraft = Minecraft.getMinecraft()

    private var isToggledLeft = false
    private var isToggledRight = false
    private var isToggledForward = false
    private var isToggledBack = false
    private var isToggledAttack = false

    private var ignoreNextKeyUp = false
    private var lastToggleKeyCode = -1

    @SubscribeEvent
    fun onTick(event: TickEvent.ClientTickEvent) {
        if (mc.gameSettings.keyBindForward.isKeyDown) isToggledForward = false
        if (mc.gameSettings.keyBindLeft.isKeyDown) isToggledLeft = false
        if (mc.gameSettings.keyBindRight.isKeyDown) isToggledRight = false
        if (mc.gameSettings.keyBindBack.isKeyDown) isToggledBack = false
        if (mc.gameSettings.keyBindAttack.isKeyDown) isToggledAttack = false
    }

    @SubscribeEvent
    fun onKeyInput(event: InputEvent.KeyInputEvent) {
        val key = Keyboard.getEventKey()
        val isPressed = Keyboard.getEventKeyState()

        if (toggleLeftWalk.isPressed) {
            Chatterbox.say("Enabled macro!")
            CaneMacroer.isMacroToggled = true
            MinecraftForge.EVENT_BUS.register(CaneMacroer)
            CaneMacroer.mc.displayGuiScreen(GuiChat(""))

            lastToggleKeyCode = key
            ignoreNextKeyUp = true
            return
        }

        if (!isPressed && ignoreNextKeyUp && key == lastToggleKeyCode) {
            ignoreNextKeyUp = false
            return
        }

        if (CaneMacroer.isMacroToggled) {
            Chatterbox.say("Macro disabled by input!")
            CaneMacroer.isMacroToggled = false
            CaneMacroer.stop()
            MinecraftForge.EVENT_BUS.unregister(CaneMacroer)
        }


//        if (toggleLeftWalk.isPressed) isToggledLeft = !isToggledLeft
//        if (toggleRightWalk.isPressed) isToggledRight = !isToggledRight
//        if (toggleForwardWalk.isPressed) isToggledForward = !isToggledForward
//        if (toggleBackwardWalk.isPressed) isToggledBack = !isToggledBack
//        if (toggleLeftMouse.isPressed) isToggledAttack = !isToggledAttack
//
//        if (isToggledLeft) (mc.gameSettings.keyBindLeft as KeyBindingAccessor).setPressed(true)
//        if (isToggledRight) (mc.gameSettings.keyBindRight as KeyBindingAccessor).setPressed(true)
//        if (isToggledForward) (mc.gameSettings.keyBindForward as KeyBindingAccessor).setPressed(true)
//        if (isToggledBack) (mc.gameSettings.keyBindBack as KeyBindingAccessor).setPressed(true)
//        if (isToggledAttack) (mc.gameSettings.keyBindAttack as KeyBindingAccessor).setPressed(true)
    }

    @SubscribeEvent
    fun onRenderOverlay(event: RenderGameOverlayEvent.Text) {
        val x = 10f
        var y = 10f

        val toggledKeys = mutableListOf<String>()
        if (isToggledForward) toggledKeys.add("W")
        if (isToggledLeft) toggledKeys.add("A")
        if (isToggledBack) toggledKeys.add("S")
        if (isToggledRight) toggledKeys.add("D")
        if (isToggledAttack) toggledKeys.add("Attack")

        if (toggledKeys.isEmpty()) return

        val boxWidth = 60
        val boxHeight = 10 + toggledKeys.size * 10

        Gui.drawRect((x - 2).toInt(), (y - 2).toInt(), (x + boxWidth).toInt(), (y + boxHeight).toInt(), 0x90000000.toInt())

        for (label in toggledKeys) {
            mc.fontRendererObj.drawStringWithShadow("[$label]", x, y, 0xFFFFFF)
            y += 10f
        }
    }
}
