package com.github.itzilly.sbt.renderer


import com.github.itzilly.sbt.util.Vecd3
import net.minecraft.client.Minecraft
import net.minecraft.client.renderer.GlStateManager
import net.minecraft.client.renderer.Tessellator
import net.minecraft.client.renderer.WorldRenderer
import net.minecraft.client.renderer.vertex.DefaultVertexFormats
import net.minecraft.util.AxisAlignedBB
import net.minecraft.util.EnumFacing
import org.lwjgl.opengl.GL11
import java.awt.Color

object RenderUtils {
    var TESSELLATOR: Tessellator = Tessellator.getInstance()
    var WORLD_RENDERER: WorldRenderer = Tessellator.getInstance().worldRenderer

    fun drawBlock(box: AxisAlignedBB, outlineStartColor: Int, outlineEndColor: Int) {
        drawBlockTop(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockBottom(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockNorth(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockEast(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockSouth(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockWest(box, Color(outlineStartColor), Color(outlineEndColor));
    }

    private fun drawBlockTop(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockBottom(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockNorth(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockEast(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockSouth(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockWest(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawLine(p1: Vecd3, p2: Vecd3, color: Color, lineWidth: Int, depth: Boolean, partialTicks: Float) {
        GlStateManager.disableCull()

        val render = Minecraft.getMinecraft().renderViewEntity
        val worldRenderer = TESSELLATOR.worldRenderer

        val realX = render.lastTickPosX + (render.posX - render.lastTickPosX) * partialTicks
        val realY = render.lastTickPosY + (render.posY - render.lastTickPosY) * partialTicks
        val realZ = render.lastTickPosZ + (render.posZ - render.lastTickPosZ) * partialTicks


        GlStateManager.pushMatrix()
        GlStateManager.translate(-realX, -realY, -realZ)
        GlStateManager.disableTexture2D()
        GlStateManager.enableBlend()
        GlStateManager.disableAlpha()
        GlStateManager.tryBlendFuncSeparate(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA, 1, 0)
        GL11.glLineWidth(lineWidth.toFloat())
        if (!depth) {
            GL11.glDisable(GL11.GL_DEPTH_TEST)
            GlStateManager.depthMask(false)
        }
        GlStateManager.color(color.red / 255f, color.green / 255f, color.blue / 255f, color.alpha / 255f)
        worldRenderer.begin(GL11.GL_LINE_STRIP, DefaultVertexFormats.POSITION)
        worldRenderer.pos(p1.x, p1.y, p1.z).endVertex()
        worldRenderer.pos(p2.x, p2.y, p2.z).endVertex()
        Tessellator.getInstance().draw()
        GlStateManager.translate(realX, realY, realZ)
        if (!depth) {
            GL11.glEnable(GL11.GL_DEPTH_TEST)
            GlStateManager.depthMask(true)
        }
        GlStateManager.disableBlend()
        GlStateManager.enableAlpha()
        GlStateManager.enableTexture2D()
        GlStateManager.color(1.0f, 1.0f, 1.0f, 1.0f)
        GlStateManager.popMatrix()
        GlStateManager.disableLighting()
        GlStateManager.enableCull()
    }

    fun drawAnimatedBlockTop(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color, time: Float) {
        val offsetY = Math.sin(time.toDouble()).toFloat() * (box.maxY - box.minY) / 2.0f

        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY + offsetY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY + offsetY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY + offsetY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY + offsetY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawAnimatedBlockBottom(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color, time: Float) {
        val offsetY = Math.sin(time.toDouble()).toFloat() * (box.maxY - box.minY) / 2.0f

        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.minY + offsetY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY + offsetY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY + offsetY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY + offsetY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawAnimatedBlockNorth(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color, time: Float) {
        val offsetY = Math.sin(time.toDouble()).toFloat() * (box.maxY - box.minY) / 2.0f

        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.maxY + offsetY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY + offsetY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY + offsetY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY + offsetY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawAnimatedBlockEast(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color, time: Float) {
        val offsetY = Math.sin(time.toDouble()).toFloat() * (box.maxY - box.minY) / 2.0f

        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.maxY + offsetY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY + offsetY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY + offsetY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY + offsetY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawAnimatedBlockSouth(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color, time: Float) {
        val offsetY = Math.sin(time.toDouble()).toFloat() * (box.maxY - box.minY) / 2.0f

        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY + offsetY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY + offsetY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY + offsetY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY + offsetY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawAnimatedBlockWest(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color, time: Float) {
        val offsetY = Math.sin(time.toDouble()).toFloat() * (box.maxY - box.minY) / 2.0f

        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY + offsetY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY + offsetY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY + offsetY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY + offsetY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    fun drawBlockFace(box: AxisAlignedBB, face: EnumFacing, color: Int) {
        WORLD_RENDERER.begin(GL11.GL_LINE_STRIP, DefaultVertexFormats.POSITION_COLOR)

        val r = (color shr 16 and 0xFF) / 255.0f
        val g = (color shr 8 and 0xFF) / 255.0f
        val b = (color and 0xFF) / 255.0f
        val a = (color shr 24 and 0xFF) / 255.0f

        GL11.glColor4f(r, g, b, a)

        when (face) {
            EnumFacing.UP -> {
                WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ).endVertex()
            }
            EnumFacing.DOWN -> {
                WORLD_RENDERER.pos(box.minX, box.minY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.minY, box.minZ).endVertex()
            }
            EnumFacing.NORTH -> {
                WORLD_RENDERER.pos(box.minX, box.minY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.minY, box.minZ).endVertex()
            }
            EnumFacing.SOUTH -> {
                WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ).endVertex()
            }
            EnumFacing.WEST -> {
                WORLD_RENDERER.pos(box.minX, box.minY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.minX, box.minY, box.minZ).endVertex()
            }
            EnumFacing.EAST -> {
                WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ).endVertex()
                WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ).endVertex()
            }
            else -> {}
        }

        TESSELLATOR.draw()
    }
}