package com.github.itzilly.sbt.util

import net.minecraftforge.common.MinecraftForge
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.common.gameevent.TickEvent


class DelayedFunction(private val function: () -> Unit, private val delayTicks: Int) {
    private var ticksLeft: Int = delayTicks

    init {
        MinecraftForge.EVENT_BUS.register(this)
    }

    @SubscribeEvent
    fun onClientTick(event: TickEvent.ClientTickEvent) {
        if (ticksLeft > 0) {
            ticksLeft--
            if (ticksLeft == 0) {
                function()
                MinecraftForge.EVENT_BUS.unregister(this)
            }
        }
    }
}