package com.github.itzilly.sbt.util

import net.minecraft.util.IChatComponent
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.common.gameevent.PlayerEvent.PlayerLoggedInEvent

object MessageScheduler {
    private val components: MutableList<IChatComponent> = mutableListOf()

    @SubscribeEvent
    fun onPlayerLoggedIn(event: PlayerLoggedInEvent) {
        val player = event.player
        for (component in components) {
            Chatterbox.say(player, component)
        }
        components.clear() // Clear the list after sending the messages
    }

    fun sayWhenReady(component: IChatComponent) {
        components.add(component)
    }
}